function [R,varargout] = residual1d(N,NH,phis,phirw,contparams,Hw,ev,diffpotential,varargin)
% with 8 input arguments, residual 
% with 9 input arguments, residual and gradient of exact penalty function
phisNH = phis(1:NH);
R = ev.*phisNH+...
    Hw*(2*contparams(1)*diffpotential.*phirw+2*contparams(2)*phirw.^3)-...
    2*phis(NH+1).*phisNH;    
R(NH+1) = N-norm(phisNH)^2;
if (nargin == 9)
    r = varargin{1};
    varargout{1} = R(1:NH)+2*(phis(NH+1)-r*sign(R(NH+1)))*phisNH;    
end    