function plots2dsys(M,xmin,xmax,c,phis,gamma,varargin)
if (nargin == 6)
  funct = inline('x');
else
  funct = varargin{1};
end
ymin = xmin;
ymax = xmax;
X = linspace(xmin,xmax,M);
Y = linspace(ymin,ymax,M);
l = length(phis);
for i = 1:l
  phir{i} = plothermite2d(X(:),Y(:),phis{i},gamma);
  phirmin(i) = min(min(feval(funct,phir{i})));
  phirmax(i) = max(max(feval(funct,phir{i})));
end
zmin = min(phirmin);
zmax = max(phirmax)
zmin = 0;
zmax = 1.9e8;
[XX,YY] = meshgrid(linspace(xmin,xmax,M),linspace(ymin,ymax,M));
for i = 1:l
  figure
  contourf(XX/sqrt(c),YY/sqrt(c),feval(funct,phir{i}),10,'EdgeColor',[0.5 0.5 0.5]);
  colormap(flipud(gray))
  set(gca,'xtick',linspace(roundf(xmin/sqrt(c)),roundf(xmax/sqrt(c)),5))
  set(gca,'ytick',linspace(roundf(ymin/sqrt(c)),roundf(ymax/sqrt(c)),5))
  axis([xmin/sqrt(c),xmax/sqrt(c),ymin/sqrt(c),ymax/sqrt(c),zmin,zmax])
  axis square
  caxis([zmin,zmax])
%  colorbar('YLim',[0 phirmax(i)])
  view(0,90)
  xlabel('x')
  ylabel('y','Rotation',0)		
%  print(sprintf('phi%d.eps',i),'-deps')
%  print(sprintf('phi%d.tex',i),'-depslatexstandalone')
end
