function f = rhs(t,psis,Hw,W,theta,lambda)
% linear part
lp = lambda.*psis/2;
% reshape
psis = reshape(psis,size(Hw{2},1),size(Hw{1},1));
% Spectral to real transforms
psir = Hw{2}'*(psis*Hw{1});
% nonlinear part
nlp = (Hw{2}*(W.*psir+theta*abs(psir).^2.*psir))*Hw{1}';
f = -sqrt(-1)*(lp+nlp(:));
